///////////////////////////////////////////////////////////////////////////////
//
// This software module was originally developed by
//
// Intel Corporation
// TU-Munich, S.Herrmann
// (contributing organizations names)
//
// in the course of development of the MPEG-7 Experimentation Model.
//
// This software module is an implementation of a part of one or more MPEG-7
// Experimentation Model tools as specified by the MPEG-7 Requirements.
//
// ISO/IEC gives users of MPEG-7 free license to this software module or
// modifications thereof for use in hardware or software products claiming
// conformance to MPEG-7.
//
// Those intending to use this software module in hardware or software products
// are advised that its use may infringe existing patents. The original
// developer of this software module and his/her company, the subsequent
// editors and their companies, and ISO/IEC have no liability for use of this
// software module or modifications thereof in an implementation.
//
// Copyright is not released for non MPEG-7 conforming products. The
// organizations named above retain full right to use the code for their own
// purpose, assign or donate the code to a third party and inhibit third parties
// from using the code for non MPEG-7 conforming products.
//
// Copyright (c) 1998-1999.
//
// This notice must be included in all copies or derivative works.
//
// Applicable File Name:  CodingSchemes.h
//
#ifndef __CODING_SCHEMES_H__
#define __CODING_SCHEMES_H__
#include "XMObjects.h"                                  /* Naming Convention */
#ifdef USEDT
#include "DummyTypeCS.h"
#endif

#include "ColorSpaceCS.h"
#include "ColorQuantCS.h"
#include "GridLayoutCS.h"
#include "Spatial2DCoordinatesCS.h"
#include "TemporalInterpolationCS.h"
#include "TimeSeriesCS.h"

#include "ColorStructureCS.h"
#include "DominantColorCS.h"
#include "ColorLayoutCS.h"
#include "GoFGoPColorCS.h"
#include "ScalableColorCS.h"

#include "EdgeHistCS.h"
#include "HomoTextureCS.h"
#include "TextureBrowsingCS.h"

#include "3DShapeSpectrumCS.h"
#include "ContourShapeCS.h"
#include "MultiViewCS.h"
#include "RegionLocatorCS.h"
#include "RegionShapeCS.h"
#include "SpatioTemporalLocatorCS.h"

#include "CameraMotionCS.h"
#include "MotionTrajectoryCS.h"
#include "ParametricObjectMotionCS.h"
#include "MotionActivityCS.h"

#include "FaceRecognitionCS.h"

#include "MultiImageCS.h"

// Audio implemented MDS components
#include "ProbabilityVectorCS.h"
#include "ProbabilityMatrixCS.h"

// Spoken content stuff
#include "SpokenContentIndexEntryCS.h"
#include "SpokenContentLexiconCS.h"
#include "SpokenContentWordLexiconCS.h"
#include "SpokenContentLinkCS.h"
#include "SpokenContentWordLinkCS.h"
#include "SpokenContentPhoneLinkCS.h"
#include "SpokenContentConfusionInfoCS.h"
#include "SpokenContentPhoneLexiconCS.h"
#include "SpokenContentPhoneIndexEntryCS.h"
#include "SpokenContentWordIndexEntryCS.h"
#include "SpokenContentSpeakerCS.h"
#include "SpokenContentHeaderCS.h"
#include "SpokenContentNodeCS.h"
#include "SpokenContentBlockCS.h"
#include "SpokenContentLatticeCS.h"
#include "SpokenContentCS.h"

#include "TimePointCS.h"
#include "TimeUnitCS.h"
#include "RelTimeCS.h"
#include "RelIncrTimeCS.h"
#include "DurationCS.h"
#include "IncrDurationCS.h"

#include "GenericDSCS.h"


#endif //__CODING_SCHEMES_H__
