///////////////////////////////////////////////////////////////////////////////
//
// This software module was originally developed by
//
// Intel Corporation
// TU-Munich, S.Herrmann
// (contributing organizations names)
//
// in the course of development of the MPEG-7 Experimentation Model.
//
// This software module is an implementation of a part of one or more MPEG-7
// Experimentation Model tools as specified by the MPEG-7 Requirements.
//
// ISO/IEC gives users of MPEG-7 free license to this software module or
// modifications thereof for use in hardware or software products claiming
// conformance to MPEG-7.
//
// Those intending to use this software module in hardware or software products
// are advised that its use may infringe existing patents. The original
// developer of this software module and his/her company, the subsequent
// editors and their companies, and ISO/IEC have no liability for use of this
// software module or modifications thereof in an implementation.
//
// Copyright is not released for non MPEG-7 conforming products. The
// organizations named above retain full right to use the code for their own
// purpose, assign or donate the code to a third party and inhibit third parties
// from using the code for non MPEG-7 conforming products.
//
// Copyright (c) 1998-1999.
//
// This notice must be included in all copies or derivative works.
//
// Applicable File Name:  Descriptors.h
#ifndef __DESCRIPTORS__
#define __DESCRIPTORS__
#include "XMInterfaces.h"                             /* Naming Convention */
#include "XMObjects.h"                                /* Naming Convention */
#ifdef USEDT
#include "DummyType.h"
#endif

//#include "TemporalInter.h"
#include "TimeSeries.h"
#include "ColorSpace.h"
#include "ColorQuant.h"
#include "Spatial2DCoordinates.h"
#include "TemporalInterpolation.h"
//#include "TimeSeries.h"

#include "ColorLayout.h"
#include "ColorStructure.h"
#include "DominantColor.h"
#include "GoFGoPColor.h"
#include "ScalableColor.h"

#include "TextureBrowsing.h"
#include "GridLayout.h"
#include "HomoTexture.h"
#include "EdgeHist.h"

#include "3DShapeSpectrum.h"
#include "ContourShape.h"
#include "MultiView.h"
#include "RegionLocator.h"
#include "RegionShape.h"
#include "SpatioTemporalLocator.h"

#include "CameraMotion.h"
#include "MotionTrajectory.h"
#include "ParametricObjectMotion.h"
#include "MotionActivity.h"

#include "FaceRecognition.h"

#include "MultiImage.h"

// Audio defined MDS components
#include "ProbabilityVector.h"
#include "ProbabilityMatrix.h"

// Spoken content stuff
#include "SpokenContentIndexEntry.h"
#include "SpokenContentLexicon.h"
#include "SpokenContentWordLexicon.h"
#include "SpokenContentLink.h"
#include "SpokenContentWordLink.h"
#include "SpokenContentPhoneLink.h"
#include "SpokenContentConfusionInfo.h"
#include "SpokenContentPhoneLexicon.h"
#include "SpokenContentPhoneIndexEntry.h"
#include "SpokenContentWordIndexEntry.h"
#include "SpokenContentSpeaker.h"
#include "SpokenContentHeader.h"
#include "SpokenContentNode.h"
#include "SpokenContentBlock.h"
#include "SpokenContentLattice.h"
#include "SpokenContent.h"

#include "TimePoint.h"
#include "TimeUnit.h"
//#include "PointOfView.h"
#include "RelTime.h"
#include "RelIncrTime.h"
#include "Duration.h"
#include "IncrDuration.h"

#endif //__DESCRIPTORS__
