/***********************************************************************
This software module was originally developed by Cdric Thinot (Expway)
Claude Seyrat (Expway) and Grgoire Pau (Expway) in the course of 
development of the MPEG-7 Systems (ISO/IEC 15938-1) standard. 

This software module is an implementation of a part of one or more 
MPEG-7 Systems (ISO/IEC 15938-1) tools as specified by the 
MPEG-7 Systems (ISO/IEC 15938-1) standard. 

ISO/IEC gives users of the MPEG-7 Systems (ISO/IEC 15938-1) free license
to this software module or modifications thereof for use in hardware or
software products claiming conformance to the MPEG-7 Systems 
(ISO/IEC 15938-1). 

Those intending to use this software module in hardware or software 
products are advised that its use may infringe existing patents.

The original developer of this software module and his/her company, the
subsequent editors and their companies, and ISO/IEC have no liability
for use of this software module or modifications thereof in an
implementation. 

Copyright is not released for non MPEG-7 Systems (ISO/IEC 15938-1) 
conforming products. 

Expway retains full right to use the code for his/her own purpose, 
assign or donate the code to a third party and to inhibit third parties 
from using the code for non MPEG-7 Systems (ISO/IEC 15938-1) conforming 
products. 

This copyright notice must be included in all copies or derivative works.

Copyright Expway  2001.
************************************************************************/

package com.expway.schema;

import org.xml.sax.Attributes;

import com.expway.util.LocalHandler;
import com.expway.util.HandlerException;

import com.expway.schema.instance.Annotation;
import com.expway.schema.instance.Documentation;
import com.expway.schema.instance.AppInfo;

/**
 * AnnotationHandler.java
 *
 *
 * Created: Wed Aug 09 18:56:06 2000
 *
 * @author 
 * @version
 */

public class AnnotationHandler extends StaticLocalHandler {

    Annotation annotation;

    public AnnotationHandler () {
        
    }
    public  void informEnd(LocalHandler son) throws HandlerException {
             // dans le cas d'un default Handler$
        if (son.getCreation()== null)
                return; 
        String className= son.getClass().getName();
        if (className.equals(SchemaRegister.CLASS_ELT_APPINFO))
            annotation.setAppInfo((AppInfo)son.getCreation());
        else if (className.equals(SchemaRegister.CLASS_ELT_DOCUMENTATION))
            annotation.setDocumentation((Documentation)son.getCreation());
    }

    public void init(String uri, String local, String raw, Attributes attrs){
        annotation = new Annotation();
    }
    
    public void reset(){} 

    //TODO
    public void end(){}
    //TODO
    public Object getCreation(){ 
        return annotation;
    }

    //TODO
    public  void characters(char[] ch, int start, int length){
        //TODO envoyer une erreur
    }

}// AnnotationHandler
